/*
    Compiler: Borland C++ Version 3.1
              Turbo C++ Version 1.01

    Project: X511i.c
             lib\7186el.lib

    Hardware: uPAC-7186EX + X511i 
*/

#include <stdio.h>
#include <string.h>
#include "lib\7186e.h"

int Scanf(char *fmt, ...);

void main(void)
{
    char buf[128];
    unsigned long mytimeticks;
    int i, option, iQuit=0;
    char getChar;
    
    InitLib();
    
    // install the driver for the COM port for COM2 to COM5 in the interrupt vector, 
    // which means that all COM ports use the interrupt mechanism to read and write data
    InstallCom(2, 115200L, 8, 0, 1);
    InstallCom(3, 115200L, 8, 0, 1);
    InstallCom(4, 115200L, 8, 0, 1);
    InstallCom(5, 115200L, 8, 0, 1);
    
    Puts("\n");
    Puts("*******************************************\n");
    Puts("|  Demo program for uPAC-7186EX + XW511i  |\n");
    Puts("|                                         |\n");
    Puts("|              [Mar 21, 2019]             |\n");
    Puts("*******************************************\n");
    
    while(!iQuit) {
        Puts("\n");
        Puts("1) COM2 <-> COM3\n");
        Puts("2) COM4 <-> COM5\n");
        Puts("\n");
        Puts("0) Quit\n\n");
        Puts("Choose an option and press [Enter]: ");
        Scanf("%d", &option);
        Puts("\n");
        
        switch(option) {
            case 1:
                ClearCom(2); // clear all data in input buffer of COM2
                ToComBufn(3, "hello world", 11); // send n bytes of data via COM3
                
                memset(buf, 0, sizeof(buf));
                
                i = 0;
                mytimeticks = GetTimeTicks();
                
                do {
                    if(IsCom(2)) { // check whether there is any data in the input buffer of COM2
                        buf[i++] = ReadCom(2); // read one byte of data from the input buffer of COM2
                        
                        // read through the available bytes until all the expected bytes have been received
                        if(i >= 11) break;
                    }
                } while(GetTimeTicks() - mytimeticks < 20);
                
                if(i < 11) {
                    Print("receive timeout\n");
                }
                else {
                    buf[i] = '\0'; // add a null character at the end of a string
                    Print("Received \"%s\" via COM2\n", buf);
                }
                
                break;
                
            case 2:
                ClearCom(5); // clear all data in input buffer of COM5
                ToComStr(4, "hello world\r"); // send a string (ending with '\r') via COM4
                
                memset(buf, 0, sizeof(buf));
                
                i = 0;
                mytimeticks = GetTimeTicks();
                
                do {
                    if(IsCom(5)) {
                        getChar = ReadCom(5);
                        
                        // read through the available bytes until a '\r' character has been received
                        if((buf[i++] = getChar) == '\r')
                            break;
                    }
                } while(GetTimeTicks() - mytimeticks < 20);
                
                if(i < 12) {
                    Print("receive timeout\n");
                }
                else {
                    buf[i - 1] = '\0'; // replace the character '\r' with '\0'
                    Print("Received \"%s\" via COM5\n", buf);
                }
                break;
                
            case 0:
                iQuit = 1;
                
                // If the program calls InstallCom, 
                // the RestoreCom must be called to restore the COM Port setting before exiting the program
                RestoreCom(2);
                RestoreCom(3);
                RestoreCom(4);
                RestoreCom(5);
                break;
                
            default:
                break;
        }
        
        if(!iQuit) {
            Puts("\nPress any key to continue...\n");
            Getch();
        }
    }
}