/*
X109Demo.c: Demo program for X109

Compiler: BC++ 3.1, 
          Turbo C++ 1.01(3.01) (free from http://cc.codegear.com/free/cpp)

Compile mode: large

Project: X109Demo.c
         ..\..\Lib\7186el.lib
         ..\..\lib\Xboard\X109.lib
         
Hardware: uPAC-7186EX + X109
X109: 7 channels PhotoMOS Relay 

[Nov 02, 2008] by Liam
*/

#include <stdio.h>
#include <dos.h>
#include "..\..\lib\7186e.h"
#include "..\..\lib\Xboard\X109.h"

void main(void)
{
    int iAction, iStatus, iDOValue=0, iOutChannel, iRet, quit;
    
    InitLib();
    X109_Init();    //Initialize the X109

    Print("\r\n");
    Print("*****************************************\r\n");
    Print("|  Demo program for uPAC-7186EX + X109  |\r\n");
    Print("|                                       |\r\n");
    Print("|            [Nov 02, 2008]             |\r\n");
    Print("*****************************************\r\n");

    while(iAction!=5)
    {
        iAction=0;
        quit=0;
        
        Puts("\n\r");
        Puts("1) Write Relay output (all channels)\n\r");
        Puts("2) Write Relay output (one channel)\n\r");
        Puts("3) Relay output Readback (all channels)\n\r");
        Puts("4) Relay output Readback (one channel)\n\r");
        Puts("\n\r");
        Puts("5) Quits demo program\n\r\n\r");
        Puts("Choose an option and press [Enter]:");
        Scanf("%d",&iAction);
        Puts("\n\r");

        switch(iAction)
        {
            // Write Relay output (all channels)
            case 1:
                Print("Please input Output value(0 ~ 0x7f): ");
                Scanf("%x", &iDOValue);
                
                X109_Write_All_DO(iDOValue);

                Print("Output value=> 0x%02x\r\n\r\n", iDOValue);
            break;
            // Write Relay output (one channel)
            case 2:
                Print("Please select outport channel(0~6) and status(0:OFF, 1:ON)\n\r");
                Print("Channel number and status:");
                
                Scanf("%d %d", &iOutChannel, &iStatus);
                
                if(iOutChannel>6)
                {
                    Puts("Unknow Channel Number\r\n\r\n");
                    break;
                }
                
                X109_Write_One_DO(iOutChannel, iStatus);
                                
                Print("Channel %d ==> %s\r\n\r\n", iOutChannel, (iStatus>=1)?"ON":"OFF");
            break;
            // Relay output Readback (all channels)
            case 3:
                iDOValue=X109_Read_All_DO();
                
                Print("Digital Output ReadBack=> 0x%02x\r\n\r\n", iDOValue);
            break;
            // Relay output Readback (one channels)
            case 4:
                Print("Please select outport channel(0~6): ");
                Scanf("%d", &iOutChannel);
                
                if(iOutChannel>6)
                {
                    Puts("Unknow Channel Number\r\n\r\n");
                    break;
                }
                
                iRet=X109_Read_One_DO(iOutChannel);
                                 
                if(iRet)
                    Print("Channel %d ==> ON\r\n\r\n", iOutChannel);
                else
                    Print("Channel %d ==> OFF\r\n\r\n", iOutChannel);
            break;
            
            case 5:
            default:
                quit=1;
            break;
        }
        if(!quit)
        {
            Puts("Press any key to continue...\n\r");
            Getch();
        }
    }
}

