/*
X503Demo.c: Demo program for X503

Compiler: BC++ 3.1, 
          Turbo C++ 1.01(3.01) (free from http://cc.codegear.com/free/cpp)

Compile mode: large 

Project: X503Demo.c
         ..\..\lib\7186el.lib
         
Hardware: uPAC-7186EX + X503
X503: COM3 (5-wire RS-232)

[Nov 02, 2008] by Liam
*/

#include <stdio.h>
#include <string.h>
#include "..\..\lib\7186e.h"

#define BUFSIZE 1024

char OutpBuf[BUFSIZE], InpBuf[BUFSIZE];

void main(void)
{
    int idata, iAction, iValue, quit;
    
    InitLib();
    
    InstallCom(3, 115200L, 8, 0, 1);
    
    Print("\r\n");
    Print("*****************************************\r\n");
    Print("|  Demo program for uPAC-7186EX + X503  |\r\n");
    Print("|                                       |\r\n");
    Print("|            [Nov 02, 2008]             |\r\n");
    Print("*****************************************\r\n");
    
    while(iAction!=4)
    {
        iAction=0;
        quit=0;
        
        Print("\n\r");
        Print("1) Send & Receive data to/from COM1:\n\r");
        Print("2) Set RTS status \n\r");
        Print("3) Get CTS status (0: CTS off, 1: CTS ON)\n\r");
        Print("\n\r");
        Print("4) Quits Demo program\n\r\n\r");
        Print("Choose an option and press [Enter]:");
        Scanf("%d",&iAction);
        
        switch(iAction)
        {
            // Send & Receive data to/from COM1
            case 1:
                Print("\n\r");
                Print("Send & Receive data to/from COM1\n\r");
                Print("Enter a string to COM port:");
                Scanf("%s",&OutpBuf);
                ToComStr(3,OutpBuf);
                Delay(2);
                idata=ReadComn(3,InpBuf,BUFSIZE);
                InpBuf[idata]=0x0;
                Print("Read COM port==>%s,idata=%d\r\n",InpBuf,idata);
                if(!strcmp(OutpBuf,InpBuf))
                    Print("Send COM3 <==> Receiv COM3 -->Test OK\n\r");
                else
                    Print("Send COM3 <==> Receiv COM3 -->Test error\n\r");
                break;
                
            // Set RTS status
            case 2:
                Print("\n\r");
                Print("Input 0 or 1? ");
                Scanf("%d", &iValue);
                if(iValue)
                    SetRtsActive_3();
                else
                    SetRtsInactive_3();
                Print("\n\rThe RTS status is %d\n\r", iValue);
                break;
                
            // Get CTS status
            case 3:
                Print("\n\rCTS status of COM3 is:%d\n\r", GetCtsStatus_3());
                break;
            
            case 4:
                quit=1;
                RestoreCom(3);
                break;
                
            default:
                quit=1;
                break;
        }
        
        if(quit!=1)
        {
            Print("\n\rPress any key to continue...\n\r");
            Getch();
        }
    }
}