/*
    XDemo23: Echoes all data (include "23") to specific clients.

    Compiler: BC++ 3.1
    Compile mode: large
    Project: user.c
             v7000.c
             vModbus.c           [after vcom3002.lib]
             ..\Lib\7186EL.Lib
             ..\Lib\tcp_dm32.lib
             ..\Lib\VcomNNNN.Lib, with NNNN being the lib file's version.

    23  -> Any command will be accepted.
    
    This demo Uses VcomSendSocket to echo all data (including "23") 
    to specific clients.
    Xserver will echo all data (inclued "23") to client.

    Hareware: uPAC-7186EX

    [Dec 18, 2008] by Liam
*/

#include <string.h>
#include <stdio.h>
#include "..\lib\7186e.h"
#include "..\lib\tcpip32.h"
#include "..\lib\vxcomm.h"

char sCommand[80];

void UserCount(void)
{
    /*
    User's timer trigger function.
    Please refer to XDemo04 for detail description.
    Please refer to XDemo09 for example code.
    */
}

void UserInit(void)
{
    /*
    Initialize user's program.
    Please refer to XDemo04 for detail description.
    Please refer to XDemo09 for example code.
    */
    
    InitLib();
}

void UserLoopFun(void)
{
    /*
    VxComm.exe will call this function every scan time
    Please refer to XDemo11 for Real-time I/O control
    */   
}

int UserCmd(unsigned char *Cmd,unsigned char *Response)
{
    /*  
    Xserver executes this function when received a package 
    form TCP port 10000 and the first two bytes are "19".
    
    Funtion of Xserver, Please refer to XDemo04 for detail description.
    */  

    if (Cmd[0])     // Not Null command
    {
        strcpy(Response,Cmd);   // echo user's command back
        return 1;               // return OK
    }
    return 0;       // return ERROR

}

int VcomUserBinaryCmd(TCPREADDATA *p)
{
   /* VXCOMM.EXE 2.6.12(04,Sep,2001) or later will support this function.

    Xserver executes this function when received a package 
    form TCP port 10000 and the first two bytes are "23".
    
    Received data is stored in the TCPREADDATA structure.

    The TCPREADDATA is declared as below:    
    
        Type define t_TCPReadData{
            int Comport;
            int Socket;
            int Length;
            char* ReadUartChar;
        }TCPREADDATA; 

    user can get the following message:
    p->Socket : The index of datas. the socket number that receives the command
                when the user function wants to return a message to the client, 
                just use the socket to send data.
    p->ReadUartChar : the buffer stored the command data(include "23")
                      Maximum length of p->ReadUartChar is 32767 bytes.
                      so, the data needs triming "23".      
    p->Length : the command data length(include the two byte "23")
    
    [27,Sep,2004] by Annita
    */
     
    // echoes all data (include "23") to specific client.
    VcomSendSocket(p->Socket,p->ReadUartChar,p->Length);

    return 1;   /* any value will be accept */
}

int VcomCmdUser(TCPREADDATA *p)  
{ 
    /*
    VCOM3005 (Feb,22,2002) or later will call this function for PortUser.
    When packets received by TCP PORT PortUser(user defined) 
    of 7188E/8000E, Xserver will call this function.

    Please refer to XDemo04 for detail description.
    */
    VcomSendSocket(p->Socket,p->ReadUartChar,p->Length);
    return 1;   /* any value will be accept */  
}

void PortUserStart(int skt)
{
    /* 
    XS8_3200.Lib Version 3.2.00 (20,Apr,2004) 
    or later version supports this function.
    
    When a TCP/IP client connects to the 7188E/8000E via the user's 
    defined port(PortUser), the Xserver calls the function once.

    Please refer to XDemo04 for detail description.
    */
    
    skt=skt; //do nothing
}
  
void Port9999Start(int skt)
{
    /* 
    XS8_3200.Lib Version 3.2.00 (20,Apr,2004) 
    or later version supports this function.
    
    When a TCP/IP client connects to the 7188E/8000E TCP port 9999, 
    the Xserver calls the function once.
 
    Please refer to XDemo04 for detail description.
    */
    
    skt=skt; //do nothing
}
 
void Port502Start(int skt)
{
    /* 
    XS8_3200.Lib Version 3.2.00 (20,Apr,2004) 
    or later version supports this function.
    
    When a TCP/IP client connects to the 7188E/8000E TCP port 502, 
    the Xserver calls the function once.
    
    Please refer to XDemo04 for detail description.
    */
    
    skt=skt; //do nothing
}
